package net.ericaro.neobin;

import java.io.File;
import java.util.logging.Logger;

import net.ericaro.neobin.v1.Neobin;


public class NeoBin {

	static Logger	LOG	= Logger.getLogger("net.ericaro.neobin");

	public static BinaryFormat[] parse(File... sources) throws NeoBinException {
		BinaryFormat[] formats = new BinaryFormat[sources.length];
		try {
			int i=0;
			for (File f : sources) {
				LOG.info("Processing " + f);
				formats[i++] = new BinaryFormatBuilder().build((Neobin) FileUtil.read(f));
			}
			return formats;
		} catch (Exception e) {
			throw new NeoBinException(e);
		}
	}
	
	public static void generateJava(File target, BinaryFormat... formats) throws NeoBinException {
		try {
			for (BinaryFormat bf: formats) {
				LOG.info("Java Generating " + bf.toSmallDescription());
				BinGenerator.compile(bf, target);
			}
		} catch (Exception e) {
			throw new NeoBinException(e);
		}
	}
	public static void generateC(File target, BinaryFormat... formats) throws NeoBinException {
		try {
			for (BinaryFormat bf: formats) {
				LOG.info("C Generating " + bf.getPackageName());
				CBinGenerator.compile(bf, target);
			}
		} catch (Exception e) {
			throw new NeoBinException(e);
		}
	}

	
}
